'Global Variables
    Global BugFlag As Integer:  'Useful piece of code to see first instance of a bug
    Global HQFlag As Integer:   'Used in Beru Contest if "H" found at end of SRX
    Global Contest(10) As String: 'Select contest rules
    Global PrintOption As Integer: 'Selects report type
    Global CTVersion As Integer
    Global Band10 As Integer: 'Special case for ARRL 10m Contest
    Global ShortName$:  'was used in Superceded Shell
    Global NotFirstLoad As Integer:  'used as flag when identifying home directory
    Global NotFirstText As Integer:  'used as flag when identifying home directory
    Global HomeDir$:  'used in path to LOCAL.DAT
    Global FileName$
    Global BriefCall As String: 'Trimmed callsign passed between procedures
    Global ThisCall As String: 'Used to prepare Dupe Sheets
    
    Global PreviousDateTime As Long: 'Used to check Date time consistency
    Global CurrentDateTime As Long: 'Used to check Date time consistency
    Global NoFaults As Integer: 'Used to check Date time consistency
    Global VKZL As Integer: 'True for VKZL Contest
    Global CleanMult As String: 'Prefix packed to [4 byte]
    Global Prefix As String
    Global PrefLenMatch As Integer
    Global RDOK As String * 8: 'Stores DX that is OK for RD Test
    Global FirstModeByte As String * 1
    Global FirstMode As String * 4
    Global RSText As String * 6
    Global FirstRST As Integer
    Global FontChoice As String
    Global PaperChoice As String
    Global QSOPerPage As Integer
    
    Global GTotQSO As Long: 'Grand total of all logged QSO's
    Global TotQSO(5) As Integer:  'Total QSO's for Band(n)

    Global TotGoodQSO As Integer: ' Total valid QSO's for scoreing
    Global TotGoodCall(5) As Integer: 'Valid QSO's for Band(n)
    Global TotPref(5) As Integer: 'Total prefix multipliers for Band(n)
    Global TotPoints(5) As Long: 'Total Points for Band(n)
    Global TotPointTally As Long: 'Total Points All Bands
    Global TotPrefTally As Long: 'Total prefix multipliers for all Bands

    Global PageTotQSO As Integer: 'Keeps running totals on Log printout
    Global PageTotMults As Integer
    Global PageTotPts As Long
    Global CumTotQSO As Integer
    Global CumTotMults As Integer
    Global CumTotPts As Long
    
    Global BandName(5) As String * 4
    Global BandGroup As Integer
    Global ModeGroup As Integer
    
    Global All4Call(40) As String: 'All 4 Char + " " callsigns for Band
    Global All5Call(40) As String: 'All 5 Char + " " callsigns for Band
    Global All6Call(40) As String: 'All 6 Char + " " callsigns for Band
    Global AllXCall(40) As String: 'All other + " " callsigns for Band
    
    Global All2Pref(40) As String: 'List of [2 byte] prefixes for Band
    Global AllXPref(40) As String: 'List of [3 or 4 byte] prefixes for Band
    Global LocalPrefix As String: 'List of local prefixes
    Global BeruPrefix As String: 'List of BERU prefixes
    Global BeruBonus(1, 5, 200) As Integer: 'BERU Bonus Cumulative Totals
    Global Prefect(5, 50) As Integer: 'JA Prefectures worked
    Global CoverLine() As String
    
    Global I As Integer
    Global J As Integer
    Global K As Long
    Global L As Integer
    Global M As Integer
    Global Slash As Integer
    Global Const ONE% = 1
    Global Const ONEDAY& = 86400
    
    Global QRB(5) As Integer: 'QSO Record for BAND(n)
    Global band As String * 1: 'byte used by ct for band

    Global MyCall$: 'CT Record
    Global CTVers$: 'CT Record
    Global CType$: 'CT Record

    Type ScoreLine
        Mult As String * 4
        Dupe As Integer
        Pts As Integer
    End Type

    Type QSOLine
        Call As String * 16
        Srx As String * 8
        band As String * 1
        Mode As String * 1
        VFOCode As String * 1
        RadioNum As String * 1
        RST As Integer
        Stx As Integer
        Special2 As String * 2
        FreqA As Long
        FreqB As Long
        CDate As Long
        Special3 As String * 4
    End Type

    Global Log160() As QSOLine
    Global Log80() As QSOLine
    Global Log40() As QSOLine
    Global Log20() As QSOLine
    Global Log15() As QSOLine
    Global Log10() As QSOLine

    
    Global Score160() As ScoreLine
    Global Score80() As ScoreLine
    Global Score40() As ScoreLine
    Global Score20() As ScoreLine
    Global Score15() As ScoreLine
    Global Score10() As ScoreLine

    
    
    Global PrefList() As String * 5
    Global PrefPage() As String * 5
    Global DupeList() As String * 14
    Global DupePage() As String * 14
    Global BreakQSO() As Integer
    Global BreakMult() As Integer
    Global StartHour As Integer
    Global Mins As Long
    Global UTC_flag$
    Global ScoreTable(39, 2) As Integer

Sub CleanCallsign (Callsign$, QSOScore As ScoreLine)
    
    'Removes uninitialised characters from 16 byte Callsign$
    'Prefix holds 2 or 3 byte string
    'BriefCall has a space added to the right of callsign
    Portable = False
    L = InStr(Callsign$, Chr$(0))
    L = L - ONE
    Callsign$ = Left$(Callsign$, L)
    BriefCall = Callsign$ & " "
    
    Slash = InStr(Callsign$, "/")
      M = Int(L / 2)
      If Slash <= M Then
        'Prefix is at front of call
        GoSub Front
      Else
        'Prefix is behind a slash
        If L = Slash + ONE Then
          'Only one character after slash
          Portable = True
          Last$ = Right$(Callsign$, 1)
          If Last$ > Chr$(57) Then
            'Portable character designator - use front prefix
            GoSub Front
          Else
            'Portable number designator - use front prefix
            GoSub Front
            M = Len(Prefix)
            Prefix = Left$(Prefix, M - 1) & Last$
          End If
        Else
          'Full Prefix is behind the slash
          Prefix = Right$(Callsign$, L - Slash)
            Last$ = Right$(Prefix, 1)
              If Last$ < Chr$(58) And Last$ > Chr$(47) Then
                'Last Character is a number - all done
              Else
                'Need to add a zero or test for QRP
                If Len(Prefix) > 2 Then
                  'Probably QRP - use front prefix
                  GoSub Front
                Else
                  Prefix = Prefix & "0"
                End If
              End If
        End If
      End If


      Select Case Form1.List1.ListIndex
        Case Is = 0
          'VK/ZL Contest
'Form1.Label3.Caption = Prefix & PrefLenMatch
          If Len(Prefix) > PrefLenMatch Then
          'Prefix is => length of my prefix
            L = InStr(1, LocalPrefix, Prefix)
            If L > 0 Then
              'No need to test further for VK9_
              'because VK9 is only one prefix in WPX

              'Local - Score table column 1
              
              QSOScore.Dupe = ONE
            Else
              'DX - Score table column 2
              QSOScore.Dupe = 2
            End If
          Else
            'DX - Score table column 2
            QSOScore.Dupe = 2
          End If
          If Prefix = "MM0" Then
            QSOScore.Mult = ""
            GoSub Front
          Else
            QSOScore.Mult = Prefix
          End If
        Case Is = 1
          'RD Contest
          If Len(Prefix) > PrefLenMatch Then
          'Prefix is => length of my prefix
            L = InStr(1, LocalPrefix, Prefix)
            If L > 0 Then
              'Local - Score table column 1
              QSOScore.Dupe = ONE
            Else
              'DX - Exclude DX other than:
              'ZL, P2, VK0, VK9 - Listed in RDOK
              'If Left$(Prefix, 2) <> "ZL" And Left$(Prefix, 2) <> "P2" Then
              Check$ = Left$(Prefix, 2)
              L = InStr(1, RDOK, Check$)
              If L > 0 Then
                'This DX is OK for RD contest
                QSOScore.Dupe = 2
              Else
                QSOScore.Dupe = 0
              End If
            End If
          Else
            'DX - to be excluded
            QSOScore.Dupe = 0
          End If
          QSOScore.Mult = Prefix
        Case Is = 2
          'John Moyle FD Field
          QSOScore.Dupe = 2
          QSOScore.Mult = Prefix
        Case Is = 3
          'John Moyle FD Home
          If Portable Then
            QSOScore.Dupe = 2
          Else
            'Worked a Home Station
            QSOScore.Dupe = 1
          End If
          QSOScore.Mult = Prefix
        Case Is = 4
          'JA Contest
            'DX - Exclude DX other than:
            'J, 7
            If Left$(Prefix, 1) = "J" Or Left$(Prefix, 1) = "7" Then
              If Mid$(Prefix, 2, 1) < "T" And Mid$(Prefix, 2, 1) > "8" Then
                'This DX is OK for JA contest
                  QSOScore.Dupe = 2
              Else
                QSOScore.Dupe = 0
              End If
            End If
              
            Prefix = ""
            QSOScore.Mult = ""

        Case Is = 5
          'BERU Contest
          'All QSO points to be taken from the local table
          'Bonus points to be taken from mult table until limit is reached
          'in the CumTot for BeruBonus(Band, Index)

          'Check to see if the prefix is OK for Commonwealth Contest
          Check$ = Left$(Prefix, 1)
          If Check$ = "G" Or Check$ = "M" Then
            'OK for BERU
            QSOScore.Dupe = 1
          
          Else
            Check$ = Left$(Prefix, 2)
            If Check$ = "HQ" Then
              'OK for BERU
              QSOScore.Dupe = 1

            Else
              Check$ = "-" & Left$(Prefix, 3)
              L = InStr(1, BeruPrefix, Check$)
              If L > 0 Then
                'This prefix is OK for BERU
                QSOScore.Dupe = ONE
              Else
                QSOScore.Dupe = 0
              End If
            End If
          End If
          
          'Get Index to area part on prefix
          Check$ = "-" & Left$(Prefix, 2)
          I = InStr(1, BeruPrefix, Check$)
          'Check if two character + wild card prefix
          If I > 0 Then
            Check$ = Mid$(BeruPrefix, I + 1, 3)
            If Right$(Check$, 1) = "*" Then
              'This is a 2 letter area code. e.g. 6Y
              'Any third character belongs to the same area as 6Y
              'Therefore we strip third character and set index for bonus table
              Prefix = Left$(Prefix, 2)
              L = I + 1
              'This prefix is OK for BERU
              QSOScore.Dupe = ONE

            Else
              'No wild card found
              'no change needed
            End If
          End If
          
          
          
          
          
          
          
          
          'Next line is needed to clean up garbage in field memory
          QSOScore.Mult = ""
        Case Else
      End Select

      'Mults
      
      
Exit Sub

Front:
          A$ = Mid$(Callsign$, 3, 1)
          If A$ < Chr$(58) And A$ > Chr$(47) Then
            'Three character prefix
            Prefix = Left$(Callsign$, 3)
          Else
            A$ = Mid$(Callsign$, 2, 1)
            If A$ < Chr$(58) And A$ > Chr$(47) Then
              'Two character prefix
              Prefix = Left$(Callsign$, 2)
            Else
              Prefix = Left$(Callsign$, 2) & "0"
            End If
          End If
Return

End Sub

Sub CleanString (DirtyS$, CleanS$)
    L = InStr(DirtyS$, Chr$(0))
    L = L - ONE
    CleanS$ = Left$(DirtyS$, L)
End Sub

Sub ConvertMode (Source$, Mode$)
    Select Case Source$
      Case Is = Chr$(1)
        Mode$ = "CW  "
      Case Is = Chr$(2)
        Mode$ = "SSB  "
      Case Is = Chr$(3)
        Mode$ = "RTTY  "
      Case Else
        Mode$ = "?  "
    End Select
End Sub

Sub FixDates ()
    
    'Determine total number of QSO's
    TotBytes& = FileLen(FileName$)
    If CTVersion = 9 Then
      Headlen = 4096
      QSOlen = 50
    End If
    If CTVersion = 8 Then
      Headlen = 1024
      QSOlen = 50
    End If
    
    Open FileName$ For Binary As #1
      
      StartPos = Headlen + 43
      LastPos = Headlen + QSOlen * GTotQSO
      NoFaults = True
      Get #1, StartPos, PreviousDateTime
      
      'FIX for date too low by one day
      For K = StartPos To LastPos Step QSOlen
        Get #1, K, CurrentDateTime
        
        If CurrentDateTime < PreviousDateTime Then
          CurrentDateTime = CurrentDateTime + ONEDAY&
        
          Put #1, K, CurrentDateTime
          PreviousDateTime = CurrentDateTime
          If NoFaults Then
            NoFaults = False
            QRecord& = 1 + (K - Headlen - 43) / QSOlen
          End If
        End If
      Next K
    
      'FIX for date too high by one day
      'Works well - but give more testing before release
      'For K = StartPos To LastPos Step QSOlen
        'Get #1, K, CurrentDateTime
        
        'If CurrentDateTime > (PreviousDateTime + ONEDAY&) Then
          'CurrentDateTime = CurrentDateTime - ONEDAY&
          
          
          'Put #1, K, CurrentDateTime
          'PreviousDateTime = CurrentDateTime
          'If NoFaults Then
            'NoFaults = False
            'QRecord& = 1 + (K - Headlen - 43) / QSOlen
          'End If
        'End If
      'Next K
    
    Close #1
    
    
    If NoFaults = True Then
      MsgBox "No corrections were required", 64, "Dates Checked OK"
    Else
      Message$ = "Corrections commenced at serial number " & Str$(QRecord&) & Chr(10) & "The File will now be re-loaded"
      MsgBox Message$, 64, "Dates Fixed"
    End If

End Sub

Sub FixTimes (Mins)
    
    'Determine total number of QSO's
    TotBytes& = FileLen(FileName$)
    If CTVersion = 9 Then
      Headlen = 4096
      QSOlen = 50
    End If
    If CTVersion = 8 Then
      Headlen = 1024
      QSOlen = 50
    End If
    
    Open FileName$ For Binary As #1
      
      StartPos = Headlen + 43
      LastPos = Headlen + QSOlen * GTotQSO
      NoFaults = True
      Get #1, StartPos, PreviousDateTime
      
      For K = StartPos To LastPos Step QSOlen
        Get #1, K, CurrentDateTime
        CurrentDateTime = CurrentDateTime + (Mins * 60)
        Put #1, K, CurrentDateTime
      Next K
    Close #1
    
    MsgBox Message$, 64, "Times Fixed"

End Sub

Sub GetBreakdown ()
    
    Select Case Form1.List1.ListIndex
      Case Is = 0
        'VKZL Contest
        StartHour = 10
        
        'Testing time for 10m contest using VKZL Contest
        'StartHour = 0

      Case Is = 1
        'RD Contest
        StartHour = 8
      Case Is = 2, 3
        'John Moyle Field Day
        StartHour = 1
      Case Is = 4
        'JA Contest
        StartHour = 23
      Case Is = 5
        'BERU
        StartHour = 12
      Case Else
        StartHour = 8
    End Select
    
    'Determine the first QSO Date Code
    
    
    K = 2147483646
    If K > Log160(1).CDate And Log160(1).CDate > 0 Then K = Log160(1).CDate
    If K > Log80(1).CDate And Log80(1).CDate > 0 Then K = Log80(1).CDate
    If K > Log40(1).CDate And Log40(1).CDate > 0 Then K = Log40(1).CDate
    If K > Log20(1).CDate And Log20(1).CDate > 0 Then K = Log20(1).CDate
    If K > Log15(1).CDate And Log15(1).CDate > 0 Then K = Log15(1).CDate
    If K > Log10(1).CDate And Log10(1).CDate > 0 Then K = Log10(1).CDate

    Dim DateTimeGroup As Long
    Dim DateGroup As Long
    Dim StartGroup As Long
    
    If UTC_flag$ = Chr$(0) Then
      DateTimeGroup = K / 86400
      DateGroup = Int(DateTimeGroup)
      'StartGroup = (DateGroup * 86400) - 61200 + (3600& * StartHour): 'original
      StartGroup = (DateGroup * 86400) + 25200 + (3600& * StartHour): 'add 7 hours
    Else
      DateTimeGroup = K / 86400
      DateGroup = Int(DateTimeGroup)
      StartGroup = (DateGroup * 86400) + (3600& * StartHour): ' add zero hours
    End If
    
    '160m
      For I = 1 To TotQSO(0)
        HourIndex = Int((Log160(I).CDate - StartGroup) / 3600)
        'Form1.Label3.Caption = HourIndex
        If HourIndex < 0 Then
          StartGroup = StartGroup - ONEDAY&
          HourIndex = Int((Log40(I).CDate - StartGroup) / 3600)
        End If
        If HourIndex < 48 Then
          If Score160(I).Pts > 0 Then
            BreakQSO(HourIndex, 0) = BreakQSO(HourIndex, 0) + 1
            If Mid$(Score160(I).Mult, 1, 1) > "." Then
              BreakMult(HourIndex, 0) = BreakMult(HourIndex, 0) + 1
           End If
          End If
        End If
      Next I
      
    '80m
      For I = 1 To TotQSO(1)
        HourIndex = Int((Log80(I).CDate - StartGroup) / 3600)
        'Form1.Label3.Caption = HourIndex
        If HourIndex < 0 Then
          StartGroup = StartGroup - ONEDAY&
          HourIndex = Int((Log40(I).CDate - StartGroup) / 3600)
        End If
        If HourIndex < 48 Then
          If Score80(I).Pts > 0 Then
            BreakQSO(HourIndex, 1) = BreakQSO(HourIndex, 1) + 1
            If Mid$(Score80(I).Mult, 1, 1) > "." Then
              BreakMult(HourIndex, 1) = BreakMult(HourIndex, 1) + 1
            End If
          End If
        End If
      Next I

    '40m
      For I = 1 To TotQSO(2)
        HourIndex = Int((Log40(I).CDate - StartGroup) / 3600)
        If HourIndex < 0 Then
          StartGroup = StartGroup - ONEDAY&
          HourIndex = Int((Log40(I).CDate - StartGroup) / 3600)
        End If
        If HourIndex < 48 Then
          If Score40(I).Pts > 0 Then
            BreakQSO(HourIndex, 2) = BreakQSO(HourIndex, 2) + 1
            If Mid$(Score40(I).Mult, 1, 1) > "." Then
              BreakMult(HourIndex, 2) = BreakMult(HourIndex, 2) + 1
            End If
          End If
        End If
      Next I
    
    '20m
      For I = 1 To TotQSO(3)
        HourIndex = Int((Log20(I).CDate - StartGroup) / 3600)
        'Form1.Label3.Caption = HourIndex
        If HourIndex < 0 Then
          StartGroup = StartGroup - ONEDAY&
          HourIndex = Int((Log40(I).CDate - StartGroup) / 3600)
        End If
        If HourIndex < 48 Then
          If Score20(I).Pts > 0 Then
            BreakQSO(HourIndex, 3) = BreakQSO(HourIndex, 3) + 1
            If Mid$(Score20(I).Mult, 1, 1) > "." Then
              BreakMult(HourIndex, 3) = BreakMult(HourIndex, 3) + 1
            End If
          End If
        End If
      Next I

    '15m
      For I = 1 To TotQSO(4)
        HourIndex = Int((Log15(I).CDate - StartGroup) / 3600)
        If HourIndex < 0 Then
          StartGroup = StartGroup - ONEDAY&
          HourIndex = Int((Log40(I).CDate - StartGroup) / 3600)
        End If
        If HourIndex < 48 Then
          If Score15(I).Pts > 0 Then
            BreakQSO(HourIndex, 4) = BreakQSO(HourIndex, 4) + 1
            If Mid$(Score15(I).Mult, 1, 1) > "." Then
              BreakMult(HourIndex, 4) = BreakMult(HourIndex, 4) + 1
            End If
          End If
        End If
      Next I

    '10m
      For I = 1 To TotQSO(5)
        HourIndex = Int((Log10(I).CDate - StartGroup) / 3600)
        If HourIndex < 0 Then
          StartGroup = StartGroup - ONEDAY&
          HourIndex = Int((Log40(I).CDate - StartGroup) / 3600)
        End If
        If HourIndex < 48 Then
          If Score10(I).Pts > 0 Then
            BreakQSO(HourIndex, 5) = BreakQSO(HourIndex, 5) + 1
            If Mid$(Score10(I).Mult, 1, 1) > "." Then
              BreakMult(HourIndex, 5) = BreakMult(HourIndex, 5) + 1
            End If
          End If
        End If
      Next I
    
      'Column totals
      
      'Day 1
      For BandNum = 0 To 5
        BreakQSO(48, BandNum) = 0
        BreakMult(48, BandNum) = 0
        For I = 0 To 23
          BreakQSO(48, BandNum) = BreakQSO(48, BandNum) + BreakQSO(I, BandNum)
          BreakMult(48, BandNum) = BreakMult(48, BandNum) + BreakMult(I, BandNum)
        Next I
      Next BandNum

      'Day 2
      For BandNum = 0 To 5
        BreakQSO(49, BandNum) = 0
        BreakMult(49, BandNum) = 0
        For I = 24 To 47
          BreakQSO(49, BandNum) = BreakQSO(49, BandNum) + BreakQSO(I, BandNum)
          BreakMult(49, BandNum) = BreakMult(49, BandNum) + BreakMult(I, BandNum)
        Next I
      Next BandNum
      
      'Total both days
      For BandNum = 0 To 5
        BreakQSO(50, BandNum) = BreakQSO(48, BandNum) + BreakQSO(49, BandNum)
        BreakMult(50, BandNum) = BreakMult(48, BandNum) + BreakMult(49, BandNum)
      Next BandNum

    'Hour Totals
    For I = 0 To 47
      For BandNum = 0 To 5
        BreakQSO(I, 6) = BreakQSO(I, 6) + BreakQSO(I, BandNum)
        BreakMult(I, 6) = BreakMult(I, 6) + BreakMult(I, BandNum)
      Next BandNum
    Next I
    
    BreakQSO(0, 7) = BreakQSO(0, 6)
    BreakMult(0, 7) = BreakMult(0, 6)
    For I = 1 To 47
      BreakQSO(I, 7) = BreakQSO(I - 1, 7) + BreakQSO(I, 6)
      BreakMult(I, 7) = BreakMult(I - 1, 7) + BreakMult(I, 6)
    Next I
    
    For I = 48 To 50
      For BandNum = 0 To 5
        BreakQSO(I, 7) = BreakQSO(I, 7) + BreakQSO(I, BandNum)
        BreakMult(I, 7) = BreakMult(I, 7) + BreakMult(I, BandNum)
      Next BandNum
    Next I


End Sub

Sub GetConfiguration ()
    On Error GoTo ConfigFileError
    'On Error Resume Next
    
    ConfigFileName$ = HomeDir$ & "\QS.CFG"

    ErrorCode = 0
    
    ReDim CoverLine(31)
    Dim Dummy$
    
    I = 1
    Open ConfigFileName$ For Input As #1
      Do Until EOF(1)
        Line Input #1, Dummy$
        CoverLine(I) = Dummy$
        I = I + ONE
      Loop
    Close #1
    
    CoverSheet.Text1 = CoverLine(1)
    CoverSheet.Text2 = CoverLine(2)
    CoverSheet.Text3 = CoverLine(3)
    CoverSheet.Text4 = CoverLine(4)
    CoverSheet.Text5 = CoverLine(5)
    CoverSheet.Text6 = CoverLine(6)
    CoverSheet.Text7 = CoverLine(7)
    CoverSheet.Text8 = CoverLine(8)
    CoverSheet.Text9 = CoverLine(9)
    CoverSheet.Text10 = CoverLine(10)
    CoverSheet.Text11 = CoverLine(11)
    CoverSheet.Text12 = CoverLine(12)
    CoverSheet.Text13 = CoverLine(13)
    CoverSheet.Text14 = CoverLine(14)
    CoverSheet.Text15 = CoverLine(15)
    CoverSheet.Text16 = CoverLine(16)

    If I > 17 Then
      For J = 17 To I
        CoverSheet.Text16 = CoverSheet.Text16 & Chr(13) & Chr(10) & CoverLine(J)
      Next J
    End If

    'Form1.Label1.Caption = LocalPrefix

Exit Sub

ConfigFileError:
    MsgBox "File " & ConfigFileName$ & Chr$(10) & " not found or exceeds 30 line limit.", 48, "Config File"
    ErrorCode = Err
    End
End Sub

Sub GetLocalPrefixes ()
    'Get local prefixes to be excluded from VK/ZL Oceania Contest
    'Get Commonwealth prefixes which are OK for BERU contest

    On Error GoTo LocalFileError
    'On Error Resume Next
    
    If NotFirstLoad Then
        'No changes needed
    Else
        HomeDir$ = CurDir$
        NotFirstLoad = True
    End If
    
    LocalFileName$ = HomeDir$ & "\LOCAL.DAT"

    ErrorCode = 0
    
    Dim Dummy$
    LocalPrefix = ""

    'Open "Local.Dat" For Input As #1
    Open LocalFileName$ For Input As #1
      Do Until EOF(1)
        Line Input #1, Dummy$
        LocalPrefix = LocalPrefix & Dummy$ & " "
      Loop
    Close #1
    'Form1.Label1.Caption = LocalPrefix

    'BERU -----------------------------------------------

    LocalFileName$ = HomeDir$ & "\BERU.DAT"

    
    BeruPrefix = ""

    'Open "BERU.DAT" For Input As #1
    Open LocalFileName$ For Input As #1
      Do Until EOF(1)
        Line Input #1, Dummy$
        Dummy$ = Left$(Dummy$, 4)
        Dummy$ = RTrim$(Dummy$)
        Select Case Len(Dummy$)
          Case Is = 0
          Case Is = 1
            BeruPrefix = BeruPrefix & Left$(Dummy$, 1) & "----"
          Case Is = 2
            BeruPrefix = BeruPrefix & Left$(Dummy$, 2) & "---"
          Case Is = 3
            BeruPrefix = BeruPrefix & Left$(Dummy$, 3) & "--"
          Case Else
            BeruPrefix = BeruPrefix & Dummy$ & "-"
        End Select
      Loop
    Close #1
    'Form1.Label3.Caption = BeruPrefix
    'Each BERU Prefix/Area has a space allocated for an accumulated bonus by band
    'in the array BeruBonus(1,5,200)
     
Exit Sub

LocalFileError:
    'MsgBox "File Error" & Str$(Err), 48, "Editor"
    MsgBox "File " & LocalFileName$ & Chr$(10) & " not found.", 48, "Local Prefix File"
    ErrorCode = Err
    'LocalFileName$ = HomeDir$ & "\LOCAL.DAT"
    'LocalFileName$ = ""
    'Resume Next
    End

End Sub

Sub GetScore (A$, M, QSOScore As ScoreLine, Rec%)
    'Global BriefCall contains trimed Callsign$ + " " - done in cleancallsign.
    'Global CleanMult contains prefix & " "
    'A$ = Chr$(1) for CW or Chr$(2) for SSB
    'M = Band/Mode Index to score table
    'Rec% = Record number for band
    'QSOScore.Dupe is a temporary index:
    '  0 = 0 points - reset when Rcvd serial = 0 (by ReadBinFile)
    '  1 = Local points table
    '  2 = DX points table
   
  'Checks if Rcvd Serial is zero - QSOSCore.Dupe set to 0
  'If zero then bypass prefix and callsign checks
  
  If QSOScore.Dupe > 0 Then

      'Check for Duplicate
      J = M
      DupeFlag = False
      Select Case Len(BriefCall)
        Case Is = 5
          L = InStr(1, All4Call(J), BriefCall)
          If L = 0 Then
            'It is a new Call - add to list
              All4Call(J) = All4Call(J) & BriefCall
              TotGoodCall(M) = TotGoodCall(M) + ONE
          Else
            'Duplicate - remove points from record
            QSOScore.Pts = 0
            QSOScore.Mult = "DUPE"
            DupeFlag = True

          End If
        Case Is = 6
          L = InStr(1, All5Call(J), BriefCall)
          If L = 0 Then
            'It is a new Call - add to list
              All5Call(J) = All5Call(J) & BriefCall
              TotGoodCall(M) = TotGoodCall(M) + ONE
          Else
            'Duplicate - remove points from record
            QSOScore.Pts = 0
            QSOScore.Mult = "DUPE"
            DupeFlag = True
          End If
        Case Is = 7
          L = InStr(1, All6Call(J), BriefCall)
          If L = 0 Then
            'It is a new Call - add to list
              All6Call(J) = All6Call(J) & BriefCall
              TotGoodCall(M) = TotGoodCall(M) + ONE
          Else
            'Duplicate - remove points from record
            QSOScore.Pts = 0
            QSOScore.Mult = "DUPE"
            DupeFlag = True
          End If
        Case Else
          L = InStr(1, AllXCall(J), BriefCall)
          If L = 0 Then
            'It is a new Call - add to list
              AllXCall(J) = AllXCall(J) & BriefCall
              TotGoodCall(M) = TotGoodCall(M) + ONE
          Else
            'Duplicate - remove points from record
            QSOScore.Pts = 0
            QSOScore.Mult = "DUPE"
            DupeFlag = True
          End If
      End Select


  
  If QSOScore.Mult <> "DUPE" Then
  
    'Look up points in points table

    J = M
    If A$ = Chr$(2) Then J = J + 20
    QSOScore.Pts = ScoreTable(J, QSOScore.Dupe)

    
    'Debug code only
    'If Left$(QSOScore.Mult, 3) = "KH9" Then
      'S$ = Len(QSOScore.Mult)
      'Form1.Label3.Caption = QSOScore.Mult & "..." & S$
    'End If
    
  
    If Form1.List1.ListIndex = 5 Then
      'BERU Contest
        
      'If BugFlag = False Then
        'Form1.Label3.Caption = MyCall$
        'BugFlag = True
      'End If

      If HQFlag = True Then
        Prefix = "HQ0"
        HQFlag = False
      Else
        'Not HQ therefore check for own area
        Check$ = Left$(MyCall$, 4)
        L = InStr(Check$, Prefix)
        If L > 0 Then
          'This contact is in my call area
            QSOScore.Pts = 0
            QSOScore.Mult = ""
        End If
      End If
    End If
    
    'If points > 0 then Check if prefix has been worked or bonus table full
    
    If QSOScore.Pts > 0 Then
      
      If Form1.List1.ListIndex = 5 Then
        'BERU Contest
        'Check Bonus Status in BeruBonus(Group, Band, BonusIndex)
        'BonusIndex = Relative Position in BeruPrefix string


        
        'Check if G or M station
        Check$ = Left$(BriefCall, 1)
        If Check$ = "G" Or Check$ = "M" Then
          'first box reserved for G Bonus
          L = 2
          'Check if the G is a HQ
          If Prefix = "HQ0" Then
            Prefix = "HQ"
            N = 1
            QSOScore.Mult = "HQ"
          Else
            N = 0
          End If
        Else
          'Check if HQ Station
          If Prefix <> "HQ0" Then
            'Not HQ station
            N = 0
          Else
            'HQ station therefore need to get real prefix
            N = 1
            Temp$ = Mid$(BriefCall, 3, 1)
            If Temp$ < Chr$(58) And Temp$ > Chr$(47) Then
              'Three Character Prefix
              Prefix = Left$(BriefCall, 3)
            Else
              Temp$ = Mid$(BriefCall, 2, 1)
              If Temp$ < Chr$(58) And Temp$ > Chr$(47) Then
                'Two Character Prefix
                Prefix = Left$(BriefCall, 2)
              Else
                Prefix = Left$(BriefCall, 2)
              End If
            End If
          End If
        
          'Get Index to received prefix
          Check$ = "-" & Prefix
          L = InStr(1, BeruPrefix, Check$)
          
          'Check for alias prefix to a call area
          If L > 0 Then
            Check$ = Mid$(BeruPrefix, L + 1, 4)
            Check$ = RTrim$(Check$)
            If Right$(Check$, 1) = "=" Then
              'This is an alias for the main (next) prefix in the list
              'Get the main prefix and its index L
              Check$ = Mid$(BeruPrefix, L + 6, 4)
              If Right$(Check$, 1) = "-" Then Check$ = Left$(Check$, 3)
              If Right$(Check$, 1) = "-" Then Check$ = Left$(Check$, 2)
              Prefix = Check$
              Temp$ = "-" & Check$
              L = InStr(1, BeruPrefix, Temp$) + 1
            End If
          Else
            'This is not an alias
          End If
          
          'Get Index to area part on prefix
          Check$ = "-" & Left$(Prefix, 2)
          I = InStr(1, BeruPrefix, Check$)
          'Check if two character + wild card prefix
          If I > 0 Then
            Check$ = Mid$(BeruPrefix, I + 1, 3)
            If Right$(Check$, 1) = "*" Then
              'This is a 2 letter area code. e.g. 6Y
              'Any third character belongs to the same area as 6Y
              'Therefore we strip third character and set index for bonus table
              Prefix = Left$(Prefix, 2)
              L = I + 1
            Else
              'No wild card found
              'no change needed
            End If
          End If
              
          'Calculate index to Bonus table
          L = (L + 4) / 5
        End If
        
        'Check if own area
        If N = 0 Then
          Check$ = Left$(MyCall$, 4)
          I = InStr(Check$, Prefix)
          If I > 0 Then
            'This contact is in my call area
            QSOScore.Pts = 0
          End If
         End If
        
        If QSOScore.Pts > 0 Then
          If BeruBonus(N, M, L) < 60 Then
            'This QSO adds bonus points to (Group, Band, Area) Group = HQ or not HQ
            
            
              BeruBonus(N, M, L) = BeruBonus(N, M, L) + 20
              QSOScore.Pts = QSOScore.Pts + 20
        
            
            If N = 1 Then
              QSOScore.Mult = "HQ"
              Else
              'Not HQ
              Temp$ = Left$(Prefix, 1)
              If Temp$ = "G" Or Temp$ = "M" Then Prefix = "G"
              QSOScore.Mult = Prefix
            End If
            TotPref(M) = TotPref(M) + ONE
            'QSOScore.Dupe = ONE
          End If
        End If

      Else
        'Not BERU Contest

        CleanMult = Prefix & " "
        Select Case Len(Prefix)
          Case Is = 0
            'JA Contest uses prefectures in .SRX as multiplier
            Select Case M
              Case Is = 0
                '160m
                Prefecture% = Val(Log160(Rec%).Srx)
              Case Is = 1
                '80m
                Prefecture% = Val(Log80(Rec%).Srx)
              Case Is = 2
                '40m
                Prefecture% = Val(Log40(Rec%).Srx)
              Case Is = 3
                '20m
                Prefecture% = Val(Log20(Rec%).Srx)
              Case Is = 4
                '15m
                Prefecture% = Val(Log15(Rec%).Srx)
              Case Is = 5
                '10m
                Prefecture% = Val(Log10(Rec%).Srx)
              Case Else
            End Select
            If Prefecture% < 51 Then
              If Prefect(M, Prefecture%) Then
                'Already worked on this band
                QSOScore.Mult = ""
              Else
                Prefect(M, Prefecture%) = True
                QSOScore.Mult = Str$(Prefecture%)
                TotPref(M) = TotPref(M) + ONE
              End If
            End If
          Case Is = 2
            L = InStr(1, All2Pref(J), CleanMult)
            If L = 0 Then
              'It is a new Multiplier - add to list
              All2Pref(J) = All2Pref(J) & CleanMult
              TotPref(M) = TotPref(M) + ONE
              
              'Note: Subscript M adds CW & SSB together
              'Use J if separate CW & SSB totals are required
              'Summary Display would also need to be modified
              'Totals dimensions could be raised to about 40
    
            
            Else
              'Not New - remove from record
              QSOScore.Mult = ""
            End If
          Case Else
            L = InStr(1, AllXPref(J), CleanMult)
            If L = 0 Then
              'It is a new Multiplier - add to list
              AllXPref(J) = AllXPref(J) & CleanMult
              TotPref(M) = TotPref(M) + ONE
            Else
              'Not New - remove from record
              QSOScore.Mult = ""
            End If
        End Select
      End If

      'Form1.Label3.Caption = QSOScore.Mult
      'Form1.Label1.Caption = AllPref(J)
      'Stop
    
    
      TotPoints(M) = TotPoints(M) + QSOScore.Pts
    Else
      QSOScore.Mult = ""
    End If
  Else
      'Not valid QSO because no serial number received
      QSOScore.Mult = ""
  End If
    If DupeFlag = True Then
      QSOScore.Mult = "DUPE"
      DupeFlag = False
    End If
  End If

    'Form1.Label3.Caption = BriefCall
    'Form1.Label1.Caption = AllCall(J)
    'Stop
    'Form1.Label1.Caption = Str$(J)
    'Form1.Label3.Caption = Str$(QSOScore.Dupe)
    
End Sub

Sub HidePrefects ()
    Form1.Label21.Visible = False
    Form1.Label22.Visible = False
    Form1.Label23.Visible = False
    Form1.Label24.Visible = False
    Form1.Label25.Visible = False
    Form1.Label26.Visible = False
    Form1.Label27.Visible = False
    Form1.Label28.Visible = False
    Form1.Label31.Visible = False
    Form1.Label32.Visible = False
    Form1.Label33.Visible = False
    Form1.Label34.Visible = False
    Form1.Label35.Visible = False
    Form1.Label36.Visible = False
    Form1.Label37.Visible = False
End Sub

Function Justify$ (Source$, RequiredLength)
    'Source$ = String to be padded
    'Justify$ is returned with required padding
    'Length = total characters required
    GivenLength = Len(Source$)
    If GivenLength < RequiredLength Then
      PadLength = RequiredLength - GivenLength
      PS$ = String$(PadLength, " ")
      Justify$ = PS$ & Source$
    Else
      Justify$ = Source$
    End If
End Function

Sub PreparePrefects ()
        
        Pref$ = ""
        Pref$ = String$(19, " ")
        Pref$ = Pref$ & "1 1 1 1 1 1 1 1 1 1 2 2 2 2 2 2 2 2 2 2 "
        Pref$ = Pref$ & "3 3 3 3 3 3 3 3 3 3 4 4 4 4 4 4 4 4 4 4 5"
        Form1.Label21.Caption = Pref$
        
        Pref$ = ""
        For I = 1 To 50
          J = I Mod 10
          Pref$ = Pref$ + Str$(J)
        Next I
        Form1.Label22.Caption = Pref$

        '160m
        J = 0: UpdatePrefect J, Pref$
        Form1.Label23.Caption = Pref$
        '80 m
        J = 1: UpdatePrefect J, Pref$
        Form1.Label24.Caption = Pref$
        '40 m
        J = 2: UpdatePrefect J, Pref$
        Form1.Label25.Caption = Pref$
        '20m
        J = 3: UpdatePrefect J, Pref$
        Form1.Label26.Caption = Pref$
        '15 m
        J = 4: UpdatePrefect J, Pref$
        Form1.Label27.Caption = Pref$
        '10 m
        J = 5: UpdatePrefect J, Pref$
        Form1.Label37.Caption = Pref$

End Sub

Sub PrintBand (Qline As QSOLine, BandRef, QSOScore As ScoreLine)
    
    'ConvertTime (new time format is 7 hours behind old time format)
    If UTC_flag$ = Chr$(0) Then
      DateTimeGroup = (Qline.CDate + 61200) / 86400: 'adds 17 hours
    Else
      DateTimeGroup = 1 + (Qline.CDate / 86400): 'adds 24 hours
    End If
    'ConvertDate
    DateGroup = Int(DateTimeGroup) + 25568

    Printer.Print Tab(8);
        Printer.Print Format$(DateGroup, "dd-mmm-yy");
        
    Printer.Print Tab(18);
        Printer.Print Format$(DateTimeGroup, "hh:mm");
    
    Printer.Print Tab(24);
      Printer.Print BandName(BandRef);
    
    'Convert mode
    Printer.Print Tab(28);
        ConvertMode Qline.Mode, Mode$
        Printer.Print Mode$;
    
    Printer.Print Tab(33);
      'Printer.Print QLine.Call;
      A$ = Left$(Qline.Call, 13)
      Printer.Print A$;

    Printer.Print Tab(46);
    If Mode$ = "CW  " Then
      Printer.Print "599";
    Else
      Printer.Print "59";
    End If
    
    Printer.Print Tab(50);
      A$ = Justify$(Str$(Qline.Stx), 5)
      Printer.Print A$;

    'Convert RST
    Printer.Print Tab(55);
      Printer.Print Qline.RST;

    Printer.Print Tab(60);
      CleanString Qline.Srx, A$
      Printer.Print A$;
      
    If Form1.List1.ListIndex = 1 Then
      'RD Contest has no multipliers
      If QSOScore.Mult = "DUPE" Then
        Printer.Print Tab(65);
        Printer.Print QSOScore.Mult;
      End If
    Else
      Printer.Print Tab(65);
      Printer.Print QSOScore.Mult;
    End If

    Printer.Print Tab(72);
      A$ = Justify$(Str$(QSOScore.Pts), 6)
      Printer.Print A$;
      Printer.Print

    'Update running totals
    If QSOScore.Pts > 0 Then
      PageTotQSO = PageTotQSO + ONE
      CumTotQSO = CumTotQSO + ONE
      PageTotPts = PageTotPts + QSOScore.Pts
      CumTotPts = CumTotPts + QSOScore.Pts
      'If Left$(QSOScore.Mult, 1) > "." Then
      'If Mid$(QSOScore.Mult, 2, 1) > "." Then
      If Mid$(QSOScore.Mult, 1, 1) > "." Then
        PageTotMults = PageTotMults + ONE
        CumTotMults = CumTotMults + ONE
      End If
    End If
End Sub

Sub ReadBinFile ()
    'Get Data from CT.Bin contest file
    
    Form1.Grid2.Visible = False
    
    'Determine total number of QSO's
    TotBytes& = FileLen(FileName$)
    If CTVersion = 9 Then
      Headlen = 4096
      QSOlen = 50
    End If
    If CTVersion = 8 Then
      Headlen = 1024
      QSOlen = 50
    End If
    
    GTotQSO = (TotBytes& - Headlen) / QSOlen
    
    TotGoodQSO = 0
    TotPointTally = 0
    TotPrefTally = 0
    
    For I = 0 To 5
      TotQSO(I) = 0
      TotGoodCall(I) = 0
      TotPoints(I) = 0
      TotPref(I) = 0
      QRB(I) = 0
    Next I
    
    For J = 0 To 5
      For I = 0 To 50
        Prefect(J, I) = 0
      Next I
    Next J

    
    Band10 = False
    DXPDN = False
    
    If Left$(CType$, 9) = "ARRL 10 M" Then
      Band10 = True
      TotQSO(5) = GTotQSO
    Else
      If Left$(CType$, 10) = "DXpedition" Then
      DXPDN = True
      End If
    End If

    Open FileName$ For Binary As #1
    'Determine number of QSO's on each band.
    If GTotQSO > 0 Then
      StartPos = Headlen + 25
      LastPos = Headlen + 25 + QSOlen * GTotQSO
      
      band = " "
      If Not Band10 Then
        For K = StartPos To LastPos Step QSOlen
          Get #1, K, band
            Select Case band
              Case Is = Chr$(1)
                TotQSO(0) = TotQSO(0) + ONE
              Case Is = Chr$(2)
                TotQSO(1) = TotQSO(1) + ONE
              Case Is = Chr$(3)
                TotQSO(2) = TotQSO(2) + ONE
              Case Is = Chr$(4)
                If Not DXPDN Then
                  'band is 20m Else 30m
                  TotQSO(3) = TotQSO(3) + ONE
                End If
              Case Is = Chr$(5)
                If Not DXPDN Then
                  'band is 15m Else 20m
                  TotQSO(4) = TotQSO(4) + ONE
                Else
                  TotQSO(3) = TotQSO(3) + ONE
                End If
              Case Is = Chr$(6)
                If Not DXPDN Then
                  'band is 10m Else 17m
                  TotQSO(5) = TotQSO(5) + ONE
                End If
              Case Is = Chr$(7)
                If Not DXPDN Then
                  'band is VHF Else 15m
                Else
                  TotQSO(4) = TotQSO(4) + ONE
                End If
              Case Is = Chr$(8)
                'If NOT DXPDN Then band is VHF Else 12m
              Case Is = Chr$(9)
                If Not DXPDN Then
                  'band is VHF Else 10m
                Else
                  TotQSO(5) = TotQSO(5) + ONE
                End If
              Case Else
            End Select
        Next K
      End If
    
    'Dimension Arrays for each band
    
    ReDim Log160(TotQSO(0) + ONE) As QSOLine
    ReDim Log80(TotQSO(1) + ONE) As QSOLine
    ReDim Log40(TotQSO(2) + ONE) As QSOLine
    ReDim Log20(TotQSO(3) + ONE) As QSOLine
    ReDim Log15(TotQSO(4) + ONE) As QSOLine
    ReDim Log10(TotQSO(5) + ONE) As QSOLine

    ReDim Score160(TotQSO(0) + ONE) As ScoreLine
    ReDim Score80(TotQSO(1) + ONE) As ScoreLine
    ReDim Score40(TotQSO(2) + ONE) As ScoreLine
    ReDim Score20(TotQSO(3) + ONE) As ScoreLine
    ReDim Score15(TotQSO(4) + ONE) As ScoreLine
    ReDim Score10(TotQSO(5) + ONE) As ScoreLine

    

    
    'ReDim Pref160(TotQSO(0) + ONE) As String * 4
    'ReDim Pref80(TotQSO(1) + ONE) As String * 4
    'ReDim Pref40(TotQSO(2) + ONE) As String * 4
    'ReDim Pref20(TotQSO(3)+ ONE) As String * 4
    'ReDim Pref15(TotQSO(4) + ONE) As String * 4
    'ReDim Pref10(TotQSO(5) + ONE) As String * 4

    'ReDim Dupe160(TotQSO(0) + ONE) As String * 16
    'ReDim Dupe80(TotQSO(1) + ONE) As String * 16
    'ReDim Dupe40(TotQSO(2) + ONE) As String * 16
    'ReDim Dupe20(TotQSO(3)+ ONE) As String * 16
    'ReDim Dupe15(TotQSO(4) + ONE) As String * 16
    'ReDim Dupe10(TotQSO(5) + ONE) As String * 16

      For I = 1 To 5
      QRB(I) = 0
      Next I

      For I = 0 To 40
        All4Call(I) = ""
        All5Call(I) = ""
        All6Call(I) = ""
        AllXCall(I) = ""
        All2Pref(I) = ""
        AllXPref(I) = ""
      Next I

      StartPos = Headlen + ONE
      LastPos = Headlen + QSOlen * GTotQSO

      Get #1, StartPos + 42, PreviousDateTime
      
      For K = StartPos To LastPos Step QSOlen
        
        If Band10 Then
          band = Chr$(6)
        Else
          Get #1, K + 24, band
        End If
          Select Case band
            Case Is = Chr$(1)
              QRB(0) = QRB(0) + ONE
              Get #1, K, Log160(QRB(0))
              CleanCallsign Log160(QRB(0)).Call, Score160(QRB(0))
              If Val(Log160(QRB(0)).Srx) = 0 Then Score160(QRB(0)).Dupe = 0
              
              '160m debug data error with high serial sent (stx)
              If Log160(QRB(0)).Stx > 27591 Then
                Log160(QRB(0)).Stx = Log160(QRB(0)).Stx - 27591
              End If
              'end of debug for 160m
              
              If Form1.List1.ListIndex = 5 Then
                'BERU Contest Flag a HQ station
                Check$ = Left$(Log160(QRB(1)).Srx, 4)
                Temp% = InStr(Check$, "H")
                If Temp% > 0 Then
                  HQFlag = True
                Else
                  HQFlag = False
                End If
              End If

              GetScore Log160(QRB(0)).Mode, 0, Score160(QRB(0)), QRB(0)
            
            Case Is = Chr$(2)
              QRB(1) = QRB(1) + ONE
              Get #1, K, Log80(QRB(1))
              CleanCallsign Log80(QRB(1)).Call, Score80(QRB(1))
              If Val(Log80(QRB(1)).Srx) = 0 Then Score80(QRB(1)).Dupe = 0
              
              '80m debug data error with high serial sent (stx)
              If Log80(QRB(1)).Stx > 27591 Then
                Log80(QRB(1)).Stx = Log80(QRB(1)).Stx - 27591
              End If
              'end of debug for 80m
              
              If Form1.List1.ListIndex = 5 Then
                'BERU Contest Flag a HQ station
                Check$ = Left$(Log80(QRB(1)).Srx, 4)
                Temp% = InStr(Check$, "H")
                If Temp% > 0 Then
                  HQFlag = True
                Else
                  HQFlag = False
                End If
              End If
              
              GetScore Log80(QRB(1)).Mode, 1, Score80(QRB(1)), QRB(1)
            
            Case Is = Chr$(3)
              QRB(2) = QRB(2) + ONE
              Get #1, K, Log40(QRB(2))
              CleanCallsign Log40(QRB(2)).Call, Score40(QRB(2))
              If Val(Log40(QRB(2)).Srx) = 0 Then Score40(QRB(2)).Dupe = 0
              
              '40m debug data error with high serial sent (stx)
              If Log40(QRB(2)).Stx > 27591 Then
                Log40(QRB(2)).Stx = Log40(QRB(2)).Stx - 27591
              End If
              'end of debug for 40m
              
              If Form1.List1.ListIndex = 5 Then
                'BERU Contest Flag a HQ station
                Check$ = Left$(Log40(QRB(2)).Srx, 4)
                Temp% = InStr(Check$, "H")
                If Temp% > 0 Then
                  HQFlag = True
                Else
                  HQFlag = False
                End If
              End If
              
              GetScore Log40(QRB(2)).Mode, 2, Score40(QRB(2)), QRB(2)
              
            Case Is = Chr$(4)
              If Not DXPDN Then
                'band is 20m Else 30m
                QRB(3) = QRB(3) + ONE
                Get #1, K, Log20(QRB(3))
                CleanCallsign Log20(QRB(3)).Call, Score20(QRB(3))
                If Val(Log20(QRB(3)).Srx) = 0 Then Score20(QRB(3)).Dupe = 0
                
              '20m debug data error with high serial sent (stx)
              If Log20(QRB(3)).Stx > 27591 Then
                Log20(QRB(3)).Stx = Log20(QRB(3)).Stx - 27591
              End If
              'end of debug for 20m
                
                If Form1.List1.ListIndex = 5 Then
                  'BERU Contest Flag a HQ station
                  Check$ = Left$(Log20(QRB(3)).Srx, 4)
                  Temp% = InStr(Check$, "H")
                  If Temp% > 0 Then
                    HQFlag = True
                  Else
                   HQFlag = False
                  End If
                End If
                
      'If BugFlag = False Then
        'Form1.Label3.Caption = BriefCall & Check$
        'BugFlag = True
      'End If
       'CleanString
                GetScore Log20(QRB(3)).Mode, 3, Score20(QRB(3)), QRB(3)
              End If
            
            Case Is = Chr$(5)
              If Not DXPDN Then
                'band is 15m Else 20m
                QRB(4) = QRB(4) + ONE
                Get #1, K, Log15(QRB(4))
                CleanCallsign Log15(QRB(4)).Call, Score15(QRB(4))
                If Val(Log15(QRB(4)).Srx) = 0 Then Score15(QRB(4)).Dupe = 0
              
              '15m debug data error with high serial sent (stx)
              If Log15(QRB(4)).Stx > 27591 Then
                Log15(QRB(4)).Stx = Log15(QRB(4)).Stx - 27591
              End If
              'end of debug for 15m
                
                If Form1.List1.ListIndex = 5 Then
                  'BERU Contest Flag a HQ station
                  Check$ = Left$(Log15(QRB(4)).Srx, 4)
                  Temp% = InStr(Check$, "H")
                  If Temp% > 0 Then
                    HQFlag = True
                  Else
                    HQFlag = False
                  End If
                End If
                GetScore Log15(QRB(4)).Mode, 4, Score15(QRB(4)), QRB(4)
              Else
                QRB(3) = QRB(3) + ONE
                Get #1, K, Log20(QRB(3))
                CleanCallsign Log20(QRB(3)).Call, Score20(QRB(3))
                If Val(Log20(QRB(3)).Srx) = 0 Then Score20(QRB(3)).Dupe = 0
                
              '20m debug data error with high serial sent (stx)
              If Log20(QRB(3)).Stx > 27591 Then
                Log20(QRB(3)).Stx = Log20(QRB(3)).Stx - 27591
              End If
              'end of debug for 20m
                
                
                If Form1.List1.ListIndex = 5 Then
                  'BERU Contest Flag a HQ station
                  Check$ = Left$(Log20(QRB(3)).Srx, 4)
                  Temp% = InStr(Check$, "H")
                  If Temp% > 0 Then
                    HQFlag = True
                  Else
                    HQFlag = False
                  End If
                End If
                GetScore Log20(QRB(3)).Mode, 3, Score20(QRB(3)), QRB(3)
              End If
            
            Case Is = Chr$(6)
              If Not DXPDN Then
                'band is 10m Else 17m
                QRB(5) = QRB(5) + ONE
                Get #1, K, Log10(QRB(5))
                'If Log10(QRB(5)).CDate < PreviousDateTime Then
                  'Log10(QRB(5)).CDate = Log10(QRB(5)).CDate + ONEDAY&
                  'Put #1, K + 42, Log10(QRB(5)).CDate
                'End If
                'PreviousDateTime = Log10(QRB(5)).CDate
                CleanCallsign Log10(QRB(5)).Call, Score10(QRB(5))
                If Val(Log10(QRB(5)).Srx) = 0 Then Score10(QRB(5)).Dupe = 0
                
              '10m debug data error with high serial sent (stx)
              If Log10(QRB(5)).Stx > 27591 Then
                Log10(QRB(5)).Stx = Log10(QRB(5)).Stx - 27591
              End If
              'end of debug for 10m

                
                If Form1.List1.ListIndex = 5 Then
                  'BERU Contest Flag a HQ station
                  Check$ = Left$(Log10(QRB(5)).Srx, 4)
                  Temp% = InStr(Check$, "H")
                  If Temp% > 0 Then
                    HQFlag = True
                  Else
                    HQFlag = False
                  End If
                End If
                GetScore Log10(QRB(5)).Mode, 5, Score10(QRB(5)), QRB(5)
              End If
            Case Is = Chr$(7)
              If Not DXPDN Then
                'band is VHF Else 15m
              Else
                QRB(4) = QRB(4) + ONE
                Get #1, K, Log15(QRB(4))
                CleanCallsign Log15(QRB(4)).Call, Score15(QRB(4))
                If Val(Log15(QRB(4)).Srx) = 0 Then Score15(QRB(4)).Dupe = 0
                
              '15m debug data error with high serial sent (stx)
              If Log15(QRB(4)).Stx > 27591 Then
                Log15(QRB(4)).Stx = Log15(QRB(4)).Stx - 27591
              End If
              'end of debug for 15m
                
                
                If Form1.List1.ListIndex = 5 Then
                  'BERU Contest Flag a HQ station
                  Check$ = Left$(Log15(QRB(4)).Srx, 4)
                  Temp% = InStr(Check$, "H")
                  If Temp% > 0 Then
                    HQFlag = True
                  Else
                    HQFlag = False
                  End If
                End If
                GetScore Log15(QRB(4)).Mode, 4, Score15(QRB(4)), QRB(4)
              End If
            
            Case Is = Chr$(8)
              'If NOT DXPDN Then band is VHF Else 12m
            
            Case Is = Chr$(9)
              If Not DXPDN Then
                'band is VHF Else 10m
              Else
                QRB(5) = QRB(5) + ONE
                Get #1, K, Log10(QRB(5))
                CleanCallsign Log10(QRB(5)).Call, Score10(QRB(5))
                If Val(Log10(QRB(5)).Srx) = 0 Then Score10(QRB(5)).Dupe = 0
                
              '10m debug data error with high serial sent (stx)
              If Log10(QRB(5)).Stx > 27591 Then
                Log10(QRB(5)).Stx = Log10(QRB(5)).Stx - 27591
              End If
              'end of debug for 10m
                
                
                If Form1.List1.ListIndex = 5 Then
                  'BERU Contest Flag a HQ station
                  Check$ = Left$(Log10(QRB(5)).Srx, 4)
                  Temp% = InStr(Check$, "H")
                  If Temp% > 0 Then
                    HQFlag = True
                  Else
                    HQFlag = False
                  End If
                End If
                GetScore Log10(QRB(5)).Mode, 5, Score10(QRB(5)), QRB(5)
              End If
            Case Else
          End Select
      Next K
    End If
    Close #1

End Sub

Sub Recalculate ()

End Sub

Sub ShowPrefects ()
    Form1.Label21.Visible = True
    Form1.Label22.Visible = True
    Form1.Label23.Visible = True
    Form1.Label24.Visible = True
    Form1.Label25.Visible = True
    Form1.Label26.Visible = True
    Form1.Label27.Visible = True
    Form1.Label28.Visible = True
    Form1.Label31.Visible = True
    Form1.Label32.Visible = True
    Form1.Label33.Visible = True
    Form1.Label34.Visible = True
    Form1.Label35.Visible = True
    Form1.Label36.Visible = True
    Form1.Label37.Visible = True
End Sub

Sub UpdatePrefect (J, Pref$)
        Pref$ = " "
        For I = 1 To 50
          If Prefect(J, I) Then
            Pref$ = Pref$ & "+ "
          Else
            Pref$ = Pref$ & "- "
          End If
        Next I
End Sub

Sub WriteBand (Qline As QSOLine, BandRef, QSOScore As ScoreLine)
    'ConvertTime (new date/time format is 7 hours behind old format)
    If UTC_flag$ = Chr$(0) Then
      DateTimeGroup = (Qline.CDate + 61200) / 86400: 'adds 17 hours
    Else
      DateTimeGroup = 1 + (Qline.CDate / 86400): 'adds 24 hours
    End If
    'ConvertDate
    DateGroup = Int(DateTimeGroup) + 25568

    Print #1, Tab(8);
        'Print #1, Format$(DateGroup, "mmm-dd");
        Print #1, Format$(DateGroup, "dd-mmm-yy");
        
    Print #1, Tab(18);
        Print #1, Format$(DateTimeGroup, "hh:mm");
    
    Print #1, Tab(24);
      Print #1, BandName(BandRef);
    
    'Convert mode
    Print #1, Tab(28);
        ConvertMode Qline.Mode, Mode$
        Print #1, Mode$;
    
    Print #1, Tab(33);
      'Print #1, QLine.Call;
      A$ = Left$(Qline.Call, 13)
      Print #1, A$;
    
    Print #1, Tab(46);
    
    If Mode$ = "CW  " Then
      Print #1, "599";
    Else
      Print #1, "59";
    End If

    Print #1, Tab(50);
      A$ = Justify$(Str$(Qline.Stx), 5)
      Print #1, A$;

    'Convert RST
    Print #1, Tab(55);
      Print #1, Qline.RST;

    Print #1, Tab(60);
      CleanString Qline.Srx, A$
      Print #1, A$;
    
    If Form1.List1.ListIndex = 1 Then
      'RD Contest has no multipliers
      If QSOScore.Mult = "DUPE" Then
        Print #1, Tab(65);
        Print #1, QSOScore.Mult;
      End If
    Else
      Print #1, Tab(65);
      Print #1, QSOScore.Mult;
    End If

    Print #1, Tab(72);
      A$ = Justify$(Str$(QSOScore.Pts), 6)
      Print #1, A$;
      Print #1,

    'Update running totals
    If QSOScore.Pts > 0 Then
      PageTotQSO = PageTotQSO + ONE
      CumTotQSO = CumTotQSO + ONE
      PageTotPts = PageTotPts + QSOScore.Pts
      CumTotPts = CumTotPts + QSOScore.Pts
      'If Left$(QSOScore.Mult, 1) > "." Then
      'If Mid$(QSOScore.Mult, 2, 1) > "." Then
      If Mid$(QSOScore.Mult, 1, 1) > "." Then
        PageTotMults = PageTotMults + ONE
        CumTotMults = CumTotMults + ONE
      End If
    End If
'print
End Sub

